Subject: Re: [PATCH v2 0/7] gen_init_cpio: add copy_file_range / reflink support

From: David Disseldorp <[email-masked]>
Date: Tue, 19 Aug 2025 09:46:48 +1000

On Mon, 18 Aug 2025 20:40:23 +0200, Nicolas Schier wrote:

> On Thu, Aug 14, 2025 at 03:17:58PM +1000, David Disseldorp wrote:
> > This patchset adds copy_file_range() support to gen_init_cpio. When
> > combined with data segment alignment, large-file archiving performance
> > is improved on Btrfs and XFS due to reflinks (see 7/7 benchmarks).
> > 
> > cpio data segment alignment is provided by "bending" the newc spec
> > to zero-pad the filename field. GNU cpio and Linux initramfs extractors
> > handle this fine as long as PATH_MAX isn't exceeded.
> > 
> > Changes since v1 RFC
> > - add alignment patches 6-7
> > - slightly rework commit and error messages
> > - rename l->len to avoid 1/i confusion
> > 
> > David Disseldorp (7):
> >       gen_init_cpio: write to fd instead of stdout stream
> >       gen_init_cpio: support -o <output_path> parameter
> >       gen_init_cpio: attempt copy_file_range for file data
> >       gen_init_cpio: avoid duplicate strlen calls
> >       gen_initramfs.sh: use gen_init_cpio -o parameter
> >       docs: initramfs: file data alignment via name padding
> >       gen_init_cpio: add -a <data_align> as reflink optimization
> > 
> >  .../driver-api/early-userspace/buffer-format.rst   |   5 +
> >  usr/gen_init_cpio.c                                | 234 ++++++++++++++-------
> >  usr/gen_initramfs.sh                               |   7 +-
> >  3 files changed, 166 insertions(+), 80 deletions(-)
> > 
> >   
> 
> Thanks for the series!  I have found only a minor nick pick and some few
> bike-shedding things.
> 
> Reviewed-by: Nicolas Schier <[email-masked]>

Thanks a lot for the review, Nicolas!
I'll post a v3 with your suggestions addressed, as I have one further
initramfs_test.c patch to padded filename test coverage.

Cheers, David